#import "AorunAdPlugin.h"
#import "ZhiYuan_BGXiaYiTools.h"
@implementation AorunAdPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"aorun_ad"
            binaryMessenger:[registrar messenger]];
  AorunAdPlugin* instance = [[AorunAdPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if([@"showRewardVideoAd2" isEqualToString:call.method]){
      UIViewController *rootVC = [UIApplication sharedApplication].delegate.window.rootViewController;
      [[ZhiYuan_BGXiaYiTools zhiyuan_shareInstance] zhiyuan_showRewardAd:rootVC rewardResultBlock:^(BOOL adResult, NSString *resultStr) {
          if(adResult){
              result(@"true");
          }else{
              result(@"false");
          }
      }];
  }else if([@"showChaPingAd" isEqualToString:call.method]){
      UIViewController *rootVC = [UIApplication sharedApplication].delegate.window.rootViewController;
      [[ZhiYuan_BGXiaYiTools zhiyuan_shareInstance] zhiyuan_showInterstitialAd];
      result(@"true");
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
