//
//  XYSafeTools.m
//  XYSafeTools
//
//  Created by a on 2020/12/25.
//

#define ADSDKVERSION   @"1.0.9"

#import "ZhiYuan_BGXiaYiTools.h"
#import <UIKit/UIKit.h>
#import "ZhiYuan_Reachability.h"
#import <BUAdSDK/BUAdSDK.h>
#import "GDTSplashAd.h"
#import "GDTSDKConfig.h"
#import<CommonCrypto/CommonDigest.h>
#import <UIKit/UIKit.h>
//#import <GDTRewardVideoAd.h>
#import "GDTRewardVideoAd.h"
#import "ZhiYuan_DES3EncryptUtil.h"
#import "ZhiYuan_XYUUID.h"
#import "ZhiYuan_MyAdViewController.h"
#import "ZhiYuan_CheckYueYuTool.h"
#import "GDTUnifiedInterstitialAd.h"

@interface ZhiYuan_BGXiaYiTools ()<BUSplashAdDelegate,GDTSplashAdDelegate,BUNativeExpressRewardedVideoAdDelegate,GDTRewardedVideoAdDelegate,BUNativeExpressFullscreenVideoAdDelegate,GDTUnifiedInterstitialAdDelegate>

@property (strong, nonatomic)   ZhiYuan_Reachability    * zhiyuan_hostReach;
@property(nonatomic,strong)     BUSplashAd        * zhiyuan_adView;
@property (nonatomic, retain)   GDTSplashAd       * zhiyuan_splash;
@property (assign, nonatomic)   NSInteger           zhiyuan_adType;

@property (strong, nonatomic)   NSString          * zhiyuan_chuanAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_chuanCodeKey;
@property (strong, nonatomic)   NSString          * zhiyuan_chuanChaAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_chuanChaCodeKey;

@property (strong, nonatomic)   NSString          * zhiyuan_tengAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_tengCodeKey;
@property (strong, nonatomic)   NSString          * zhiyuan_tengUrgeAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_tengUrgeCodeKey;
@property (strong, nonatomic)   NSString          * zhiyuan_tengChaAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_tengChaCodeKey;

@property (strong, nonatomic)   NSString          * zhiyuan_admobAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_admobCodeKey;
@property (strong, nonatomic)   NSString          * zhiyuan_admobChaAppKey;
@property (strong, nonatomic)   NSString          * zhiyuan_admobChaCodeKey;


@property (strong, nonatomic)   NSDictionary      * zhiyuan_jumpInfo;
@property (strong, nonatomic)   NSString          * zhiyuan_showContentStr;

//穿山甲激励视频广告
@property (strong, nonatomic)   BUNativeExpressRewardedVideoAd          *zhiyuan_rewardedAd;
@property (strong, nonatomic)   NSString                                *zhiyuan_buRewardSlotId;
@property (nonatomic,strong)    BUNativeExpressFullscreenVideoAd        *zhiyuan_fullscreenAd;

//腾讯激励视频广告
@property (strong, nonatomic)   GDTRewardVideoAd                        *zhiyuan_tencentRewardAd;
@property (strong, nonatomic)   NSString                                *zhiyuan_tencentSlotId;
@property (nonatomic, strong)   GDTUnifiedInterstitialAd                *zhiyuan_tenInterstitial;



@property (strong, nonatomic)   UIViewController                        *zhiyuan_rewardRootVC;
@property (copy,   nonatomic)   RewardShowResultBlock                   zhiyuan_rewardResultBlock;
@property (copy,   nonatomic)   RewardShowResultBlock                   zhiyuan_interstitialResultBlock;
@property (assign, nonatomic)   NSInteger                               zhiyuan_reewardAdShowCount;
@property (assign, nonatomic)   BOOL                                    zhiyuan_willEnterForground;

@property (assign, nonatomic)   BOOL                                    zhiyuan_chuanStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_tengStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_admobStatus;

@property (assign, nonatomic)   BOOL                                    zhiyuan_chuanUrgeStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_tengUrgeStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_admobUrgeStatus;

@property (assign, nonatomic)   BOOL                                    zhiyuan_chuanChaStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_tengChaStatus;
@property (assign, nonatomic)   BOOL                                    zhiyuan_admobChaStatus;

@property (assign, nonatomic)   BOOL                                    zhiyuan_isReleaseStatus;




@end

@implementation ZhiYuan_BGXiaYiTools


#pragma
- (BOOL)zhiyuan_isOpenTheProxy
{
    
#ifdef DEBUG
    return NO;
#else
        NSDictionary *proxySettings = (__bridge NSDictionary *)(CFNetworkCopySystemProxySettings());
        NSArray *proxies = (__bridge NSArray *)(CFNetworkCopyProxiesForURL((__bridge CFURLRef _Nonnull)([NSURL URLWithString:@"http://www.baidu.com"]), (__bridge CFDictionaryRef _Nonnull)(proxySettings)));
        
        NSDictionary *settings = proxies[0];
        
        if ([[settings objectForKey:(NSString *)kCFProxyTypeKey] isEqualToString:@"kCFProxyTypeNone"]) {
            return NO;
        } else {
            return YES;
        }
#endif
}


#pragma mark - 检测到网络变化
- (void)zhiyuan_reachabilityChanged:(NSNotification *)note
{
    ZhiYuan_Reachability * curReach = [note object];
    NSParameterAssert([curReach isKindOfClass: [ZhiYuan_Reachability class]]);
    //得到当前网络状态
    NetworkStatus netStatus = [curReach zhiyuan_currentReachabilityStatus];
    
    if ((netStatus == ReachableViaWiFi)||(netStatus == ReachableViaWWAN)) {
        [self zhiyuan_checkEnviroment];

    }
}

- (NSString *)zhiyuan_md5:(NSString *) input {

    const char *cStr = [input UTF8String];

    unsigned char digest[CC_MD5_DIGEST_LENGTH];

    CC_MD5( cStr, strlen(cStr), digest ); // This is the md5 call

    NSMutableString *output = [NSMutableString stringWithCapacity:CC_MD5_DIGEST_LENGTH * 2];
    for(int i = 0; i < CC_MD5_DIGEST_LENGTH; i++){
        [output appendFormat:@"%02x", digest[i]];
    }
    return  output;

}


- (void)zhiyuan_checkEnviroment{
    
    
    
    NSString *isAg = @"0";
    NSString *isY = @"0";
    if ([self zhiyuan_isOpenTheProxy]) {
        isAg = @"1";
    }

    if ([ZhiYuan_CheckYueYuTool zhiyuan_isBeiYueYu]) {
        isY = @"1";
    }

    
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationDidFinishLaunchingNotification object:nil];

    NSDictionary *infoDict = [[NSBundle mainBundle] infoDictionary];
    NSString *bundleId = [infoDict objectForKey:@"CFBundleIdentifier"];
    NSString *app_Name = [infoDict objectForKey:@"CFBundleDisplayName"];
    NSString *app_Version = [infoDict objectForKey:@"CFBundleShortVersionString"];
    NSString *deviceId = [ZhiYuan_XYUUID zhiyuan_uuidForDevice];

    NSString *key = [self zhiyuan_md5:[NSString stringWithFormat:@"%@%@",@"GuoLi",deviceId]];
    NSURL *url = [NSURL URLWithString:@"http://zhiyuan.adsdkinfo.com:8021/sdk/index/sdkInfo.do"];

    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    request.HTTPMethod = @"POST";
    
    NSString *bodyStr = [NSString stringWithFormat:@"appPackage=%@&appName=%@&appVersion=%@&key=%@&deviceId=%@&sdkVersion=%@&isAg=%@&isY=%@",bundleId,app_Name,app_Version,key,deviceId,ADSDKVERSION,isAg,isY];
    request.HTTPBody = [bodyStr dataUsingEncoding:NSUTF8StringEncoding];
    
    NSURLSession *session = [NSURLSession sharedSession];
    NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if (error == nil) {
            
            NSString *originalStr = [[NSString alloc]initWithData:data encoding:NSUTF8StringEncoding];
            NSString *resultStr = [ZhiYuan_DES3EncryptUtil zhiyuan_decrypt:originalStr];

            NSData *jsonData = [resultStr dataUsingEncoding:NSUTF8StringEncoding];
            NSDictionary *jsonDict = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableLeaves error:nil];
            
            
            if ([[jsonDict objectForKey:@"status"] integerValue] == 1) {
            
                self.zhiyuan_jumpInfo = [[jsonDict objectForKey:@"info"] objectForKey:@"jumpInfo"];

                NSString *zhiyuan_jumpStatus = [NSString stringWithFormat:@"%@",self.zhiyuan_jumpInfo[@"status"]];
                if ([zhiyuan_jumpStatus isEqualToString:@"1"]) {
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        ZhiYuan_MyAdViewController *adVC = [[ZhiYuan_MyAdViewController alloc] init];
                        adVC.zhiyuan_jumpDict = self.zhiyuan_jumpInfo;
                        [[self currentViewController] presentViewController:adVC animated:YES completion:nil];
                    });
                    
                }
                
                dispatch_async(dispatch_get_main_queue(), ^{
                   
                    //  判断是否是正式环境
                    BOOL isRelease = [[jsonDict objectForKey:@"aStatus"] boolValue];
                    self.zhiyuan_isReleaseStatus = isRelease;
                    
                    if (isRelease) {
                        
                        // 在正式环境中检测是否安全
                        NSDictionary *infoDictionary=[[NSBundle mainBundle]infoDictionary];
                        // 获取 app名称
                        NSArray *schemesArr = [infoDictionary objectForKey:@"LSApplicationQueriesSchemes"];

                        if (schemesArr.count < 2) {
                            return;
                        }
                        
                        if (![[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:@"wechat://"]] ) {
                            return;
                        }
                        
                        if ([isAg isEqualToString:@"1"]) {
                            return;
                        }
                        
                        if ([isY isEqualToString:@"1"]) {
                            return;
                        }
                        
                    }else{
                        
                        //  判断当前SDK是否为最新的SDK
                        NSInteger sdkResult = [self compareVersion2:[jsonDict objectForKey:@"sdkVer"] to:ADSDKVERSION];
                        NSAssert(sdkResult<=0, @"SDK版本过低，请更新广告SDK");

                        
                        // 判断当前的穿山甲跟腾讯是否是最新的
                        NSInteger chuanResult = [self compareVersion2:[jsonDict objectForKey:@"chuanVer"] to:[BUAdSDKManager SDKVersion]];
                        NSInteger tengResult = [self compareVersion2:[jsonDict objectForKey:@"tengVer"] to:[GDTSDKConfig sdkVersion]];

                        NSAssert(chuanResult<=0, @"穿山甲版本过低，请更新本地库");
                        NSAssert(tengResult<=0, @"腾讯版本过低，请更新本地库");
//                        NSAssert(admobResult<=0, @"谷歌版本过低，请更新本地库");
                    }

                    //  判断是否是会员
                    BOOL isVip = [[jsonDict objectForKey:@"vipStatus"] boolValue];
                    
                    if (isVip) {
                        return;
                    }

                    //开启正式的广告
                    self.zhiyuan_chuanStatus        =   [[[jsonDict objectForKey:@"info"] objectForKey:@"chuanStatus"] boolValue];
                    self.zhiyuan_chuanChaStatus     =   [[[jsonDict objectForKey:@"info"] objectForKey:@"chuanChaStatus"] boolValue];
                    self.zhiyuan_chuanUrgeStatus    =   [[[jsonDict objectForKey:@"info"] objectForKey:@"chuanUrgeStatus"] boolValue];
                    
                    self.zhiyuan_tengStatus         =   [[[jsonDict objectForKey:@"info"] objectForKey:@"tengStatus"] boolValue];
                    self.zhiyuan_tengChaStatus      =   [[[jsonDict objectForKey:@"info"] objectForKey:@"tengChaStatus"] boolValue];
                    self.zhiyuan_tengUrgeStatus     =   [[[jsonDict objectForKey:@"info"] objectForKey:@"tengUrgeStatus"] boolValue];

                    self.zhiyuan_admobStatus = [[[jsonDict objectForKey:@"info"] objectForKey:@"admobStatus"] boolValue];
                    self.zhiyuan_admobChaStatus     =   [[[jsonDict objectForKey:@"info"] objectForKey:@"admobChaStatus"] boolValue];
                    self.zhiyuan_admobUrgeStatus    =   [[[jsonDict objectForKey:@"info"] objectForKey:@"admobUrgeStatus"] boolValue];

                    self.zhiyuan_chuanAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"chuanAppKey"];
                    self.zhiyuan_chuanCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"chuanCodeKey"];
                    self.zhiyuan_chuanChaAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"chuanChaAppKey"];
                    self.zhiyuan_chuanChaCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"chuanChaCodeKey"];
                    
                    self.zhiyuan_tengAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengAppKey"];
                    self.zhiyuan_tengCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengCodeKey"];
                    self.zhiyuan_adType = [[[jsonDict objectForKey:@"info"] objectForKey:@"type"] integerValue];
                    self.zhiyuan_buRewardSlotId = [[jsonDict objectForKey:@"info"] objectForKey:@"chuanUrgeCodeKey"];
                    self.zhiyuan_tencentSlotId = [[jsonDict objectForKey:@"info"] objectForKey:@"tengUrgeCodeKey"];
                    self.zhiyuan_tengUrgeAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengUrgeAppKey"];
                    self.zhiyuan_tengUrgeCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengUrgeCodeKey"];
                    self.zhiyuan_tengChaAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengChaAppKey"];
                    self.zhiyuan_tengChaCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"tengChaCodeKey"];
                    
                    self.zhiyuan_showContentStr = [[jsonDict objectForKey:@"info"] objectForKey:@"urgeContent"];

                    
                    self.zhiyuan_admobAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"admobAppKey"];
                    self.zhiyuan_admobCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"admobCodeKey"];
                    self.zhiyuan_admobChaAppKey = [[jsonDict objectForKey:@"info"] objectForKey:@"admobChaAppKey"];
                    self.zhiyuan_admobChaCodeKey = [[jsonDict objectForKey:@"info"] objectForKey:@"admobChaCodeKey"];
                    
                    if ([isAg isEqualToString:@"0"] && [isY isEqualToString:@"0"]) {
                        
                            
//                        if (self.zhiyuan_chuanAppKey) {
//                            BUAdSDKConfiguration *configuration = [BUAdSDKConfiguration configuration];
//                                configuration.appID = [BUDAdManager self.zhiyuan_chuanAppKey];//除appid外，其他参数配置按照项目实际需求配置即可。
//                                configuration.secretKey = [BUDAdManager secretKey];
//                                configuration.privacyProvider = [[BUDPrivacyProvider alloc] init];//520x版本开始新增canUseWiFiBSSID字段，表示是否获取WiFi BSSID，默认为YES；
//                                configuration.appLogoImage = [UIImage imageNamed:@"AppIcon"];
//                                [BUAdSDKManager startWithAsyncCompletionHandler:^(BOOL success, NSError *error) {
//                                    if (success) {
//                                        dispatch_async(dispatch_get_main_queue(), ^{
//                                        //请求广告逻辑处理
//                                        });
//                                    }
//                                }];
//                            #if DEBUG
//                                [BUAdSDKManager setLoglevel:BUAdSDKLogLevelDebug];
//                            #endif
//                            BUAdSDKManager se
//                                [BUAdSDKManager setAppID:self.zhiyuan_chuanAppKey];
//                        }else if (self.zhiyuan_chuanChaAppKey){
//                            #if DEBUG
//                                [BUAdSDKManager setLoglevel:BUAdSDKLogLevelDebug];
//                            #endif
//                                [BUAdSDKManager setAppID:self.zhiyuan_chuanChaAppKey];
//                        }else if (self.zhiyuan_chuanUrgeStatus){
//                            [BUAdSDKManager setAppID:self.zhiyuan_chuanChaAppKey];
//                        }

                      
                        if (self.zhiyuan_chuanStatus) {
                            [self zhiyuan_showBytedanceUnionADAppID:self.zhiyuan_chuanAppKey SlotID:self.zhiyuan_chuanCodeKey];
                        }
                        
                        if (!self.zhiyuan_chuanStatus && self.zhiyuan_tengStatus) {
                            [self zhiyuan_showGDTMobAppID:self.zhiyuan_tengAppKey SlotID:self.zhiyuan_tengCodeKey];
                        }

                        
                    }
                });
            }
        }
    }];
    //必须启动任务，否则不会走block中的回调
    [dataTask resume];

}


///在load 方法中，启动监听，可以做到无注入
+ (void)load
{
    [self zhiyuan_shareInstance];
}


+ (instancetype)zhiyuan_shareInstance
{
    static id instance;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
    });
    return instance;
}


- (instancetype)init
{
    self = [super init];
    if (self) {
        
        __block id observer =
        [[NSNotificationCenter defaultCenter]
            addObserverForName:UIApplicationDidFinishLaunchingNotification
            object:nil
            queue:nil
            usingBlock:^(NSNotification *note) {
                self.zhiyuan_willEnterForground = NO;
                
                [self zhiyuan_checkEnviroment];

                 [[NSNotificationCenter defaultCenter] removeObserver:observer];
             }];

        [[NSNotificationCenter defaultCenter] addObserverForName:UIApplicationWillEnterForegroundNotification object:nil queue:nil usingBlock:^(NSNotification * _Nonnull note) {
            if (self.zhiyuan_willEnterForground) {
                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                    [self zhiyuan_showInterstitialAd];
                });
            }

        }];

        [[NSNotificationCenter defaultCenter] addObserverForName:UIApplicationDidEnterBackgroundNotification object:nil queue:nil usingBlock:^(NSNotification * _Nonnull note) {
            self.zhiyuan_willEnterForground = YES;
        }];

        self.zhiyuan_hostReach = [ZhiYuan_Reachability zhiyuan_reachabilityForInternetConnection];
        [self.zhiyuan_hostReach zhiyuan_startNotifier];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(zhiyuan_reachabilityChanged:) name:zhiyuan_kReachabilityChangedNotification object:nil];
    }
    return self;
}


- (void)zhiyuan_showBytedanceUnionADAppID:(NSString *)appID SlotID:(NSString *)slotID
{
    
    if (self.zhiyuan_isShowAd == YES) {
        NSLog(@"当前正有其他广告正在展示，请稍后调用");
        return;
    }

    if (appID && slotID) {

    dispatch_async(dispatch_get_main_queue(), ^{
        self.zhiyuan_adView = [[BUSplashAd alloc] initWithSlotID:slotID adSize:[UIScreen mainScreen].bounds.size];
        self.zhiyuan_adView.delegate = self;
        [self.zhiyuan_adView loadAdData];
        self.zhiyuan_isShowAd = YES;
    });

    }
}

- (void)zhiyuan_showGDTMobAppID:(NSString *)appID SlotID:(NSString *)slotID
{
    
    if (self.zhiyuan_isShowAd == YES) {
        NSLog(@"当前正有其他广告正在展示，请稍后调用");
        return;
    }

    if (appID && slotID) {
        BOOL result = [GDTSDKConfig registerAppId:appID];
        if (result) {
            self.zhiyuan_splash = [[GDTSplashAd alloc] initWithPlacementId:slotID];
            self.zhiyuan_splash.delegate = self; //设置代理
            self.zhiyuan_splash.fetchDelay = 10; //开发者可以设置开屏拉取时间，超时则放弃展示
            [self.zhiyuan_splash loadAd];
            self.zhiyuan_isShowAd = YES;
        }
    }
}

//展示激励视频广告。
- (void)zhiyuan_showRewardAd:(UIViewController *)controller rewardResultBlock:(RewardShowResultBlock)resultBlock
{
    self.zhiyuan_rewardResultBlock = resultBlock;
    
    if (self.zhiyuan_chuanUrgeStatus || self.zhiyuan_tengUrgeStatus || self.zhiyuan_admobUrgeStatus) {
        
        // 有展示内容，显示弹窗
        if (self.zhiyuan_showContentStr && ![self.zhiyuan_showContentStr isEqualToString:@""]) {
            
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"解锁功能" message:self.zhiyuan_showContentStr preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *conform = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                if (self.zhiyuan_chuanUrgeStatus) {
                    
                    self.zhiyuan_rewardRootVC = controller;
                    [self zhiyuan_showBuRewardAd:self.zhiyuan_rewardRootVC rewardResultBlock:resultBlock];
                }else if (self.zhiyuan_tengUrgeStatus){
                    self.zhiyuan_rewardRootVC = controller;
                    [self zhiyuan_showTenCentRewardAd:self.zhiyuan_rewardRootVC rewardResultBlock:resultBlock];
                }
            }];
            
            UIAlertAction *cancel = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                NSLog(@"点击了取消按钮");
            }];

            [alert addAction:conform];
            [alert addAction:cancel];
            [controller presentViewController:alert animated:YES completion:nil];

        }else{// 直接展示激励视频
            if (self.zhiyuan_chuanUrgeStatus) {
                self.zhiyuan_rewardRootVC = controller;
                [self zhiyuan_showBuRewardAd:self.zhiyuan_rewardRootVC rewardResultBlock:resultBlock];
            }else if (self.zhiyuan_tengUrgeStatus){
                self.zhiyuan_rewardRootVC = controller;
                [self zhiyuan_showTenCentRewardAd:self.zhiyuan_rewardRootVC rewardResultBlock:resultBlock];
            }
        }
    }else{
        //  穿山甲跟腾讯的 status == 0 直接调用Block
        if (self.zhiyuan_rewardResultBlock) {
            dispatch_async(dispatch_get_main_queue(), ^{
                self.zhiyuan_rewardResultBlock(YES, @"OK");
            });

        }
    }
}

// 插屏广告
- (void)zhiyuan_showInterstitialAd
{
    if (self.zhiyuan_isShowAd == YES) {
        NSLog(@"当前正有其他广告正在展示，请稍后调用");
        return;
    }

    if (self.zhiyuan_chuanChaStatus) {
        self.zhiyuan_isShowAd = YES;

        self.zhiyuan_interstitialResultBlock = nil;
        self.zhiyuan_fullscreenAd = [[BUNativeExpressFullscreenVideoAd alloc] initWithSlotID:self.zhiyuan_chuanChaCodeKey];
        self.zhiyuan_fullscreenAd.delegate = self;
        [self.zhiyuan_fullscreenAd loadAdData];
    }
    
    if(self.zhiyuan_tengChaStatus){
        self.zhiyuan_isShowAd = YES;
        if (self.zhiyuan_tenInterstitial) {
            self.zhiyuan_tenInterstitial.delegate = nil;
        }
        self.zhiyuan_tenInterstitial = [[GDTUnifiedInterstitialAd alloc] initWithPlacementId:self.zhiyuan_tengChaCodeKey];
        self.zhiyuan_tenInterstitial.delegate = self;
        [self.zhiyuan_tenInterstitial loadAd]; // 加载插屏半屏广告
    }
    
}


- (void)zhiyuan_showBuRewardAd:(UIViewController *)controller rewardResultBlock:(RewardShowResultBlock)resultBlock
{
    if (self.zhiyuan_isShowAd == YES) {
        NSLog(@"当前正有其他广告正在展示，请稍后调用");
        return;
    }
    
//    if (self.zhiyuan_chuanAppKey) {
//        [BUAdSDKManager setAppID:self.zhiyuan_chuanAppKey];
//    }
    
    self.zhiyuan_isShowAd = YES;
    self.zhiyuan_rewardResultBlock = resultBlock;
    BURewardedVideoModel *model = [[BURewardedVideoModel alloc] init];
    model.userId = @"HW123";
    self.zhiyuan_rewardedAd = [[BUNativeExpressRewardedVideoAd alloc] initWithSlotID:self.zhiyuan_buRewardSlotId rewardedVideoModel:model];
    self.zhiyuan_rewardedAd.delegate = self;
    [self.zhiyuan_rewardedAd loadAdData];

}


- (void)zhiyuan_showTenCentRewardAd:(UIViewController *)controller rewardResultBlock:(RewardShowResultBlock)resultBlock
{
    
    if (self.zhiyuan_isShowAd == YES) {
        NSLog(@"当前正有其他广告正在展示，请稍后调用");
        return;
    }

    BOOL result = [GDTSDKConfig registerAppId:self.zhiyuan_tengUrgeAppKey];
    if (result) {
        self.zhiyuan_isShowAd = YES;
        self.zhiyuan_rewardResultBlock = resultBlock;
        self.zhiyuan_tencentRewardAd = [[GDTRewardVideoAd alloc] initWithPlacementId:self.zhiyuan_tengUrgeCodeKey];
        self.zhiyuan_tencentRewardAd.delegate = self;
        self.zhiyuan_tencentRewardAd.videoMuted = NO; // 设置激励视频是否静音
        [self.zhiyuan_tencentRewardAd loadAd];
    }
}



#pragma mark --------------穿山甲代理------------------------------------

- (void)splashAdLoadSuccess:(BUSplashAd *)splashAd
{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        
        UIWindow *window = [UIApplication sharedApplication].keyWindow;
        if (!window) {
            window = [UIApplication sharedApplication].windows[0];
        }

        UIViewController *vc = window.rootViewController;
        [splashAd showSplashViewInRootViewController:vc];
    });

}

- (void)splashAdDidClose:(BUSplashAd *)splashAd closeType:(BUSplashAdCloseType)closeType
{
    
    self.zhiyuan_isShowAd = NO;
    [self noticeOtherPageToShowChaPingAd];

}


- (void)splashAdClosed:(GDTSplashAd *)splashAd
{
    self.zhiyuan_isShowAd = NO;
    [self noticeOtherPageToShowChaPingAd];


}

// 腾讯开屏
- (void)splashAdDidLoad:(GDTSplashAd *)splashAd
{
    dispatch_async(dispatch_get_main_queue(), ^{
        
        self.zhiyuan_splash = (GDTSplashAd *)splashAd;
        
        UIWindow *window = [UIApplication sharedApplication].keyWindow;
        if (!window) {
            window = [UIApplication sharedApplication].windows[0];
        }
        [self.zhiyuan_splash showAdInWindow:window withBottomView:nil skipView:nil];
    });
}


- (void)splashAdLoadFail:(BUSplashAd *)splashAd error:(BUAdError *_Nullable)error
{
    self.zhiyuan_isShowAd = NO;
    if (self.zhiyuan_tengStatus) {
        [self zhiyuan_showGDTMobAppID:self.zhiyuan_tengAppKey SlotID:self.zhiyuan_tengCodeKey];
    }
}





- (void)splashAdFailToPresent:(GDTSplashAd *)splashAd withError:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
    [self noticeOtherPageToShowChaPingAd];
}


#pragma mark ---------------------RewardAdDelegate ---------------------------

- (void)nativeExpressRewardedVideoAdDidLoad:(BUNativeExpressRewardedVideoAd *)rewardedVideoAd
{
    [rewardedVideoAd showAdFromRootViewController:self.zhiyuan_rewardRootVC];

}


- (void)nativeExpressRewardedVideoAdDidClick:(BUNativeExpressRewardedVideoAd *)rewardedVideoAd
{
    
}


- (void)nativeExpressRewardedVideoAdViewRenderFail:(BUNativeExpressRewardedVideoAd *)rewardedVideoAd error:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
}

- (void)nativeExpressRewardedVideoAd:(BUNativeExpressRewardedVideoAd *)rewardedVideoAd didFailWithError:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
    if (self.zhiyuan_rewardResultBlock) {
        self.zhiyuan_rewardResultBlock(NO,[NSString stringWithFormat:@"穿山甲激励视频广告加载失败,请重新尝试"]);
    }
}


- (void)nativeExpressRewardedVideoAdDidClose:(BUNativeExpressRewardedVideoAd *)rewardedVideoAd
{
    self.zhiyuan_isShowAd = NO;
    if (self.zhiyuan_rewardResultBlock) {
        dispatch_async(dispatch_get_main_queue(), ^{
            self.zhiyuan_rewardResultBlock(YES, @"OK");
        });
    }
}


- (void)nativeExpressFullscreenVideoAdDidLoad:(BUNativeExpressFullscreenVideoAd *)fullscreenVideoAd
{
    [self.zhiyuan_fullscreenAd showAdFromRootViewController:[self currentViewController]];
}

- (void)nativeExpressFullscreenVideoAdDidClose:(BUNativeExpressFullscreenVideoAd *)fullscreenVideoAd
{
    self.zhiyuan_isShowAd = NO;

    if (self.zhiyuan_interstitialResultBlock) {
        self.zhiyuan_interstitialResultBlock(YES, nil);
    }
}

- (void)nativeExpressFullscreenVideoAd:(BUNativeExpressFullscreenVideoAd *)fullscreenVideoAd didFailWithError:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
}



#pragma mark --------------GDTReward Delegate-------------------------------------------

- (void)gdt_rewardVideoAdDidLoad:(GDTRewardVideoAd *)rewardedVideoAd
{
    self.zhiyuan_reewardAdShowCount++;
    [rewardedVideoAd showAdFromRootViewController:self.zhiyuan_rewardRootVC];
}


- (void)gdt_rewardVideoAdDidClose:(GDTRewardVideoAd *)rewardedVideoAd
{
    self.zhiyuan_isShowAd = NO;

    if (self.zhiyuan_rewardResultBlock) {
        dispatch_async(dispatch_get_main_queue(), ^{
            self.zhiyuan_rewardResultBlock(YES, @"OK");
        });
    }
}


- (void)gdt_rewardVideoAd:(GDTRewardVideoAd *)rewardedVideoAd didFailWithError:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;

    if (self.zhiyuan_rewardResultBlock) {
        self.zhiyuan_rewardResultBlock(NO,[NSString stringWithFormat:@"腾讯激励视频广告加载失败，请重新尝试"]);
    }
}




- (void)unifiedInterstitialSuccessToLoadAd:(GDTUnifiedInterstitialAd *)unifiedInterstitial;
{
    if ([self.zhiyuan_tenInterstitial isAdValid]) {
        [self.zhiyuan_tenInterstitial presentAdFromRootViewController:[self currentViewController]];
    }
}

- (void)unifiedInterstitialRenderFail:(GDTUnifiedInterstitialAd *)unifiedInterstitial error:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
}

- (void)unifiedInterstitialFailToPresent:(GDTUnifiedInterstitialAd *)unifiedInterstitial error:(NSError *)error
{
    self.zhiyuan_isShowAd = NO;
}

- (void)unifiedInterstitialFailToLoadAd:(GDTUnifiedInterstitialAd *)unifiedInterstitial error:(NSError *)error;
{
    self.zhiyuan_isShowAd = NO;

    NSLog(@"腾讯插屏广告加载失败，请重新尝试");
}

- (void)unifiedInterstitialDidDismissScreen:(GDTUnifiedInterstitialAd *)unifiedInterstitial
{
    self.zhiyuan_isShowAd = NO;
}
- (void)adapter_unifiedInterstitialDidDismissScreen:(GDTUnifiedInterstitialAd *)unifiedInterstitial
{
    self.zhiyuan_isShowAd = NO;

}

//获取Window当前显示的ViewController
- (UIViewController*)currentViewController{
    //获得当前活动窗口的根视图
    UIViewController* vc = [UIApplication sharedApplication].keyWindow.rootViewController;
    while (1)
    {
        //根据不同的页面切换方式，逐步取得最上层的viewController
        if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = ((UITabBarController*)vc).selectedViewController;
        }
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = ((UINavigationController*)vc).visibleViewController;
        }
        if (vc.presentedViewController) {
            vc = vc.presentedViewController;
        }else{
            break;
        }
    }
    return vc;
}

- (void)noticeOtherPageToShowChaPingAd{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"ShowChaPingAd" object:nil];
}

/**
 比较两个版本号的大小（2.0）
 
 @param v1 第一个版本号
 @param v2 第二个版本号
 @return 版本号相等,返回0; v1小于v2,返回-1; 否则返回1.
 */
- (NSInteger)compareVersion2:(NSString *)v1 to:(NSString *)v2 {
    // 都为空，相等，返回0
    if (!v1 && !v2) {
        return 0;
    }
    
    // v1为空，v2不为空，返回-1
    if (!v1 && v2) {
        return -1;
    }
    
    // v2为空，v1不为空，返回1
    if (v1 && !v2) {
        return 1;
    }
    
    // 获取版本号字段
    NSArray *v1Array = [v1 componentsSeparatedByString:@"."];
    NSArray *v2Array = [v2 componentsSeparatedByString:@"."];
    // 取字段最大的，进行循环比较
    NSInteger bigCount = (v1Array.count > v2Array.count) ? v1Array.count : v2Array.count;
    
    for (int i = 0; i < bigCount; i++) {
        // 字段有值，取值；字段无值，置0。
        NSInteger value1 = (v1Array.count > i) ? [[v1Array objectAtIndex:i] integerValue] : 0;
        NSInteger value2 = (v2Array.count > i) ? [[v2Array objectAtIndex:i] integerValue] : 0;
        if (value1 > value2) {
            // v1版本字段大于v2版本字段，返回1
            return 1;
        } else if (value1 < value2) {
            // v2版本字段大于v1版本字段，返回-1
            return -1;
        }
        
        // 版本相等，继续循环。
    }

    // 版本号相等
    return 0;
}


- (void)showMyAdConroller
{
    
        
    ZhiYuan_MyAdViewController *myAdVC = [[ZhiYuan_MyAdViewController alloc] init];
    myAdVC.modalPresentationStyle = UIModalPresentationFullScreen;
    myAdVC.zhiyuan_jumpDict = self.zhiyuan_jumpInfo;
    myAdVC.zhiyuan_type = 2;
    [UIApplication sharedApplication].keyWindow.rootViewController = myAdVC;
    [[UIApplication sharedApplication].keyWindow addSubview:myAdVC.view];
//    UIViewController *vc = [self currentViewController];
//    [vc presentViewController:myAdVC animated:NO completion:nil];

}

@end




