//
//  UIViewController+ChaPingAd.m
//  SafeToolTest
//
//  Created by Admin on 2021/12/11.
//
#import <objc/runtime.h>
#import "ZhiYuan_GLHookUtility.h"
#import "ZhiYuan_BGXiaYiTools.h"


@implementation UIViewController (ChaPingAd)


- (void)adViewDidLoadAppear
{
    [self adViewDidLoadAppear];
    
    NSString *className = NSStringFromClass([self class]);
    NSArray *exclusionControllerArr = [ZhiYuan_BGXiaYiTools zhiyuan_shareInstance].zhiyuan_exclusionControllerArray;
    
    if ([ZhiYuan_BGXiaYiTools zhiyuan_shareInstance]) {
        if ([exclusionControllerArr containsObject:className]) {
            return;
        }
    }
    
    if ([className containsString:@"UI"] || [className isEqualToString:@"MyAdViewController"]) {
        return;
    }
    
    [[ZhiYuan_BGXiaYiTools zhiyuan_shareInstance] zhiyuan_showInterstitialAd];

    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(showChaPingAd) name:@"ShowChaPingAd" object:nil];
}

- (void)showChaPingAd
{
    [[ZhiYuan_BGXiaYiTools zhiyuan_shareInstance] zhiyuan_showInterstitialAd];
}


+ (void)load{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        SEL originalSelector = @selector(viewDidLoad);
        SEL swizzledSelector = @selector(adViewDidLoadAppear);
        [ZhiYuan_GLHookUtility swizzlingInClass:[self class] originalSelector:originalSelector swizzledSelector:swizzledSelector];
    });
}

@end
